#ifndef __CMEM_H__
#define __CMEM_H__

#define M3_VIDEO_ID					0
#define M3_DSS_ID					1

#define CORE_VID					0
#define CORE_VPS					1
#define CORE_C674					2

#define OCMC_MEM_BUF_SIZE 		0x100
#define OCMC_MEM_BUF_LEN 		0x80

#define DM740_NUMPROCS				3

/*interrupt number*/
#define HOSTINT						77

#define DBG_MEM_BASE				0x40300000

#define DSP_BOOT_STAT          		(0x48140044)
#define DSP_BOOT_ADDR          		(0x48140048)

#define MAILBOX_BASE                0x480C8000
#define MAILBOX_SIZE				0x1000

#define MAILBOX_MESSAGE_0			(MAILBOX_BASE + 0x40)
#define MAILBOX_MESSAGE_1			(MAILBOX_BASE + 0x44)
#define MAILBOX_MESSAGE_2			(MAILBOX_BASE + 0x48)
#define MAILBOX_MESSAGE_3			(MAILBOX_BASE + 0x4C)
#define MAILBOX_MESSAGE_4			(MAILBOX_BASE + 0x50)
#define MAILBOX_MESSAGE_5			(MAILBOX_BASE + 0x54)
#define MAILBOX_MESSAGE_6			(MAILBOX_BASE + 0x58)
#define MAILBOX_MESSAGE_7			(MAILBOX_BASE + 0x5C)
#define MAILBOX_MESSAGE_8			(MAILBOX_BASE + 0x60)
#define MAILBOX_MESSAGE_9			(MAILBOX_BASE + 0x64)
#define MAILBOX_MSGSTATUS_0			(MAILBOX_BASE + 0xC0)
#define MAILBOX_MSGSTATUS_1			(MAILBOX_BASE + 0xC4)
#define MAILBOX_MSGSTATUS_2			(MAILBOX_BASE + 0xC8)
#define MAILBOX_MSGSTATUS_3			(MAILBOX_BASE + 0xCC)
#define MAILBOX_MSGSTATUS_4			(MAILBOX_BASE + 0xD0)
#define MAILBOX_MSGSTATUS_5			(MAILBOX_BASE + 0xD4)
#define MAILBOX_MSGSTATUS_6			(MAILBOX_BASE + 0xD8)
#define MAILBOX_MSGSTATUS_7			(MAILBOX_BASE + 0xDC)
#define MAILBOX_MSGSTATUS_8			(MAILBOX_BASE + 0xE0)
#define MAILBOX_MSGSTATUS_9			(MAILBOX_BASE + 0xE4)

#define MAILBOX_IRQSTATUS_CLEAR		(MAILBOX_BASE + 0x104)
#define MAILBOX_IRQENABLE_SET		(MAILBOX_BASE + 0x108)
#define MAILBOX_IRQENABLE_CLR		(MAILBOX_BASE + 0x10C)

#define MAILBOX_NUMBER_0			0/* rcv DSP */
#define MAILBOX_NUMBER_6            6/* rcv VIDEO */
#define MAILBOX_NUMBER_8            8/* rcv DSS */

#define CTRL_MODULE_BASE_ADDR		0x48140000
#define DSPMEM_SLEEP				(CTRL_MODULE_BASE_ADDR + 0x0650) 

#define DUCATI_BASE_ADDR			0x55020000
#define DUCATI_MMU_CFG				0x55080000

#define PRCM_BASE_ADDR				0x48180000

/* HDVPSS */
#define RM_HDVPSS_RSTCTRL           (PRCM_BASE_ADDR + 0x0E10)
#define CM_HDVPSS_CLKSTCTRL         (PRCM_BASE_ADDR + 0x0800)
#define CM_HDVPSS_HDVPSS_CLK_CTRL   (PRCM_BASE_ADDR + 0x0820)
#define CM_HDVPSS_HDMI_CLKCTRL      (PRCM_BASE_ADDR + 0x0824)

/* I2C */
#define CM_ALWON_I2C_02_CLKCTRL		(PRCM_BASE_ADDR + 0x1564)
#define CM_ALWON_I2C_13_CLKCTRL		(PRCM_BASE_ADDR + 0x1568)

/* MAILBOX */
#define CM_ALWON_MAILBOX_CLKCTRL 	(PRCM_BASE_ADDR + 0x1594)
#define CM_ALWON_L3_SLOW_CLKSTCTRL  (PRCM_BASE_ADDR + 0x1400)

/* DUCATI */
#define RM_DEFAULT_RSTCTRL			(PRCM_BASE_ADDR + 0x0B10)	//wushuan modify
#define RM_DEFAULT_RSTST			(PRCM_BASE_ADDR + 0x0B14)	//wushuan modify
#define CM_DEFAULT_DUCATI_CLKSTCTRL	(PRCM_BASE_ADDR + 0x0518)	//wushuan modify
#define CM_DEFAULT_DUCATI_CLKCTRL   (PRCM_BASE_ADDR + 0x0574)	//wushuan modify


#define CM_ALWON_TIMER_0_CLKCTRL      (PRCM_BASE_ADDR + 0x156C)
#define CM_ALWON_TIMER_1_CLKCTRL      (PRCM_BASE_ADDR + 0x1570) 
#define CM_ALWON_TIMER_2_CLKCTRL      (PRCM_BASE_ADDR + 0x1574) 
#define CM_ALWON_TIMER_3_CLKCTRL      (PRCM_BASE_ADDR + 0x1578) 
#define CM_ALWON_TIMER_4_CLKCTRL      (PRCM_BASE_ADDR + 0x157C) 
#define CM_ALWON_TIMER_5_CLKCTRL      (PRCM_BASE_ADDR + 0x1580) 
#define CM_ALWON_TIMER_6_CLKCTRL      (PRCM_BASE_ADDR + 0x1584)  
#define CM_ALWON_TIMER_7_CLKCTRL      (PRCM_BASE_ADDR + 0x1588) 
 
#define CM_TIMER0_CLKSEL     (PRCM_BASE_ADDR + 0x038C)	//wushuan modify
#define CM_TIMER1_CLKSEL     (PRCM_BASE_ADDR + 0x0390)	//wushuan modify
#define CM_TIMER2_CLKSEL     (PRCM_BASE_ADDR + 0x0394)	//wushuan modify
#define CM_TIMER3_CLKSEL     (PRCM_BASE_ADDR + 0x0398)	//wushuan modify
#define CM_TIMER4_CLKSEL     (PRCM_BASE_ADDR + 0x039C)	//wushuan modify
#define CM_TIMER5_CLKSEL     (PRCM_BASE_ADDR + 0x03A0)	//wushuan modify
#define CM_TIMER6_CLKSEL     (PRCM_BASE_ADDR + 0x03A4)	//wushuan modify
#define CM_TIMER7_CLKSEL     (PRCM_BASE_ADDR + 0x03A8)	//wushuan modify



#define CM_GEM_CLKSTCTRL			(PRCM_BASE_ADDR + 0x0400) 
#define CM_ACTIVE_GEM_CLKCTRL		(PRCM_BASE_ADDR + 0x0420)
#define PM_ACTIVE_PWRSTST           (PRCM_BASE_ADDR + 0x0A04)
#define RM_ACTIVE_RSTCTRL			(PRCM_BASE_ADDR + 0x0A10) 
#define RM_ACTIVE_RSTST				(PRCM_BASE_ADDR + 0x0A14) 
#define CM_MMU_CLKSTCTRL			(PRCM_BASE_ADDR + 0x140C) 
#define CM_ALWON_MMUDATA_CLKCTRL	(PRCM_BASE_ADDR + 0x159C) 
#define CM_MMUCFG_CLKSTCTRL 		(PRCM_BASE_ADDR + 0x1410) 
#define CM_ALWON_MMUCFG_CLKCTRL  	(PRCM_BASE_ADDR + 0x15A8) 


#define get_io(r)					*((volatile u_int *)(TI81XX_L4_SLOW_IO_ADDRESS(r)))
#define set_io(r,v)					*((volatile u_int *)(TI81XX_L4_SLOW_IO_ADDRESS(r))) = (v)
#define and_io(r,v)					*((volatile u_int *)(TI81XX_L4_SLOW_IO_ADDRESS(r))) &= (v)
#define or_io(r,v)					*((volatile u_int *)(TI81XX_L4_SLOW_IO_ADDRESS(r))) |= (v)


#endif /* __CMEM_H__ */

