//#include <linux/version.h>
#include <linux/module.h>
#include <linux/string.h>
#include <linux/mm.h>
#include <linux/proc_fs.h>
#include <linux/errno.h>
#include <asm/uaccess.h>
#include <linux/vmalloc.h>
#include <linux/sched.h>
#include <asm/io.h>
#include <linux/semaphore.h>
#include <linux/interrupt.h>
#include <linux/delay.h>
#include <linux/syscalls.h>
#include <linux/dma-mapping.h>
#include <asm/cacheflush.h>
#include <linux/elf.h>

#include "cpuldr.h"
#include "cmem.h"





#if 0
typedef struct {
	u_int st_name;/* offset in string table */
	u_int st_value;/* sym addr in memory */
	u_int st_size;/* 0 */
	u_char st_info;
	u_char st_other;/* 0 */
	u_short st_shndx;
} Elf32_Sym;
#endif

#define IS_LOADABLE_SECTION(x) (!( \
	(((x).flags & (  SECT_NOLOAD|SECT_DSECT|SECT_BSS| SECT_COPY)) > 0) \
	|| ((x).size == 0) \
	|| ((x).fpRawData == 0)))

typedef struct Coff_Object_tag {
    struct file *fd;
    UInt32               startAddr;
    Processor_ProcArch   procArch;
    int                 isSwapped;
    Coff_SymEntry 		*symTab;
    char 				*strTab;
    UInt32               numSymbols;
    UInt32               optHdrSize;
    UInt32               numSections;
    UInt32               stringTableSize;
    Coff_SectHdr 		*sectionInfo;
} Coff_Object ;

Coff_Object g_obj;


/* תɵļͷиṹ屣صַͳϢ */
#define MAGIC_NUMBER		0xa5c6b7d8
#define MAX_PROGRAM_ADDR	40 /* HEXļĵַ */
#define MAX_PROGRAM_SIZE	0x100000 /* DSP󳤶 1M */

typedef struct {
	u_int   magic;
	u_int   version;
	u_int   totalSecs;				/* ǰ*/
	u_int   chkSum;					/* dspۼӺ */
	u_int	blockCnt;				/*  */
	u_int	addr[MAX_PROGRAM_ADDR]; /* dspַ */
	u_int	size[MAX_PROGRAM_ADDR]; /* ݳ */
	u_int   blockOffset[MAX_PROGRAM_ADDR];
	u_int	dataLen;				/* dspܳ */
	u_int	*dataOffset;			/* dspƫ */
	u_int	bootAddr;				/* ַ */

} DSP_PROGRAM;




static Int8 Coff_read8 (struct file *fd)
{
    Int8 retVal = 0 ;
    //sys_read(fd,(Char *) &retVal,sizeof(Int8));
    fd->f_op->read (fd,&retVal,sizeof(Int8),&(fd->f_pos));
    return retVal ;
}

static Int16 Coff_read16 (struct file *fd, int swap)
{
    Int16 retVal = 0 ;
    //sys_read(fd,(Char *) &retVal,sizeof (Int16));
    fd->f_op->read (fd,(char *)&retVal,sizeof(Int16),&(fd->f_pos));
    if (swap == TRUE) {
    	retVal = BYTESWAP_WORD (retVal);
	}
    return retVal ;
}

static Int32 Coff_read32 (struct file *fd, int swap)
{
    Int32 retVal = 0 ;
    //sys_read(fd,(Char *) &retVal,sizeof (Int32));
    fd->f_op->read (fd,(char *)&retVal,sizeof(Int32),&(fd->f_pos));
	if (swap == TRUE) {
    	retVal = BYTESWAP_LONG (retVal);
    }
    return retVal ;
}

static int Coff_isValidFile(struct file *fd,Int16 magic)
{
    int    isValidFile = FALSE;
    int    isValidId   = FALSE;
    int    isValidVer  = FALSE;

    Int16   swapVal;
    UInt16  version;

    //sys_lseek(fd,0,0);
    fd->f_op->llseek (fd,0,0);

	version = (UInt16) Coff_read16 (fd, FALSE);
	if (version == COFF_VERSION) {
		isValidVer = TRUE;
	} else {
		if (BYTESWAP_WORD (version) == COFF_VERSION) {
			isValidVer = TRUE;
		}
	}

	/* Seek to the swap location. */

    //sys_lseek(fd,SWAP_LOCATION,0);
    fd->f_op->llseek (fd,SWAP_LOCATION,0);

	swapVal = Coff_read16 (fd, FALSE);
	if (swapVal == magic) {
		isValidId = TRUE;
	} else {
		if (BYTESWAP_WORD (swapVal) == magic) {
			isValidId = TRUE;
		}            
	}

	//printk("magic=%x,%x,%x\n",magic,version,swapVal);
	isValidFile = ((TRUE == isValidId) && (TRUE == isValidVer)) ;
    return isValidFile ;
}


static int Coff_isSwapped(struct file *fd)
{
    int    isSwapped = FALSE;
    Int16   swapVal;

    //sys_lseek(fd,SWAP_LOCATION,0);
	fd->f_op->llseek (fd,SWAP_LOCATION,0);
	
	swapVal = Coff_read16(fd, FALSE);
	if (swapVal != COFF_MAGIC_64x) {
		if (BYTESWAP_WORD(swapVal) == COFF_MAGIC_64x) {
			isSwapped = TRUE;
        }
	}
	return isSwapped;
}

static Int Coff_getSymTabDetails (struct file *fd, int swap,UInt32 *offsetSymTab,UInt32 *numSymbols)
{
    //sys_lseek(fd,SYMTAB_OFFSET,0);
	fd->f_op->llseek (fd,SYMTAB_OFFSET,0);
	
	*offsetSymTab = (UInt32) Coff_read32 (fd, swap);
	*numSymbols = (UInt32) Coff_read32 (fd, swap);
    return 0;
}

static char *Coff_getStringTable (Coff_Object *obj,UInt32 offsetSymTab)
{
    char *strTable = NULL;
    int swap = FALSE;
    UInt32 sizeStringTable;
    UInt32 offsetStrTable;


    swap = obj->isSwapped;
    offsetStrTable = ((obj->numSymbols) * SIZE_COFF_SYMBOL_ENTRY) + offsetSymTab;
	//sys_lseek(obj->fd,offsetStrTable,0);
	obj->fd->f_op->llseek (obj->fd,offsetStrTable,0);

	sizeStringTable  = (UInt32) Coff_read32 (obj->fd, swap);
	sizeStringTable -= 4 ;
    obj->stringTableSize = sizeStringTable;

	/* Allocate memory for string table */
	strTable = kmalloc(sizeStringTable,GFP_KERNEL);

	/* Read string table into memory */
	//sys_read(obj->fd,strTable,sizeStringTable);
	obj->fd->f_op->read (obj->fd,strTable,sizeStringTable,&(obj->fd->f_pos));
    return strTable;
}

static int Coff_getSymTable (Coff_Object *obj, UInt32 offsetSymTab, Coff_SymEntry **symTable, UInt32 *numSymbols)
{
    int swap = FALSE;
    char *symData = NULL;
    char *symDataAddress = NULL;
    Coff_SymEntry *SymEntry = NULL;

    UInt32 i,j,temp,stringTableStart;
    UInt8 temp8_1,temp8_2,temp8_3,temp8_4;

    swap = obj->isSwapped;
	
    *symTable = kmalloc(obj->numSymbols * sizeof(Coff_SymEntry),GFP_KERNEL);
	symData = kmalloc(obj->numSymbols * SIZE_COFF_SYMBOL_ENTRY,GFP_KERNEL);

	/* Store start address of symbol table */
	symDataAddress   = symData ;
	stringTableStart =  ((*numSymbols) * SIZE_COFF_SYMBOL_ENTRY) + offsetSymTab;

	/* Read symbol table into memory */
    //sys_lseek(obj->fd,offsetSymTab,0);	
	obj->fd->f_op->llseek (obj->fd,offsetSymTab,0);
	
    //sys_read(obj->fd,symData,((*numSymbols) * SIZE_COFF_SYMBOL_ENTRY));
    obj->fd->f_op->read(obj->fd,symData,((*numSymbols) * SIZE_COFF_SYMBOL_ENTRY),&(obj->fd->f_pos));

	i = 0;
	while (offsetSymTab < stringTableStart) {
		SymEntry = (Coff_SymEntry *)symData;
		for (j = 0 ; j < COFF_NAME_LEN ; j++) {
			(*symTable) [i].name [j] = SymEntry->name[j];
		}

		temp8_1 = *((UInt8 *) ((UInt32) SymEntry + 8));
		temp8_2 = *((UInt8 *) ((UInt32) SymEntry + 9));
		temp8_3 = *((UInt8 *) ((UInt32) SymEntry + 10));
		temp8_4 = *((UInt8 *) ((UInt32) SymEntry + 11));
		temp = (UInt32) ( ((UInt32) temp8_4 << 24)
			| ((UInt32) temp8_3 << 16)
			| ((UInt32) temp8_2 << 8)
			| ((UInt32) temp8_1));
		(*symTable) [i].value     = temp;
		(*symTable) [i].sectNum   = SymEntry->sectNum;
		(*symTable) [i].type      = SymEntry->type;
		(*symTable) [i].storage   = SymEntry->storage;
		(*symTable) [i].numAuxEnt = SymEntry->numAuxEnt;
		if (swap == TRUE) {
			(*symTable) [i].value = BYTESWAP_LONG ((*symTable) [i].value);
			(*symTable) [i].sectNum = BYTESWAP_WORD ((*symTable) [i].sectNum);
			(*symTable) [i].type = BYTESWAP_WORD ((*symTable) [i].type);
		}
					
		symData += SIZE_COFF_SYMBOL_ENTRY;
		offsetSymTab += SIZE_COFF_SYMBOL_ENTRY;

		if ((*symTable) [i].numAuxEnt == 1) {
			symData += SIZE_COFF_SYMBOL_ENTRY;
			offsetSymTab += SIZE_COFF_SYMBOL_ENTRY;
		}
		i++;
	}
	*numSymbols = i;

	/* Free temporary memory reserved for symbol table. */
	if (symDataAddress != NULL) {
    	kfree(symDataAddress);
		symDataAddress = NULL;
	}
    return 0;
}


static int Coff_getFileHdr(Coff_Object *obj, Coff_FileHdr *fileHdr)
{
    int status = 0;
    int swap = FALSE;

    swap = obj->isSwapped;
    //status = sys_lseek(obj->fd,0,0);
	status = obj->fd->f_op->llseek (obj->fd,0,0);

	fileHdr->version           = (UInt16) Coff_read16 (obj->fd,swap);
	fileHdr->numSections       = (UInt16) Coff_read16 (obj->fd,swap);
	fileHdr->dateTime          = Coff_read32 (obj->fd,swap);
	fileHdr->fpSymTab          = Coff_read32 (obj->fd,swap);
	fileHdr->numSymTabEntries  = Coff_read32 (obj->fd,swap);
	fileHdr->numBytesOptHeader = (UInt16) Coff_read16 (obj->fd,swap);
	fileHdr->flags             = (UInt16) Coff_read16 (obj->fd,swap);
	fileHdr->targetId          = (UInt16) Coff_read16 (obj->fd,swap);

    return status;
}

static UInt32 Coff_getOptHdrSize(struct file *fd, int swap)
{
    UInt32 optHdrSize = 0u;
	//sys_lseek(fd,SIZE_OPT_HDR_LOC,0);
	fd->f_op->llseek (fd,SIZE_OPT_HDR_LOC,0);
	
	optHdrSize = Coff_read16 (fd, swap);
    return optHdrSize;
}

static int Coff_getOptHdr(Coff_Object *obj,Coff_OptHdr *optHdr,UInt32 *optHdrSize)
{
    int  status = 0;
    int  swap = FALSE;
    Int32 numBytesOptHeader = 0;

    swap = obj->isSwapped;

    numBytesOptHeader = Coff_getOptHdrSize (obj->fd,swap);

	*optHdrSize = numBytesOptHeader;

	/* Seek to the location of the Optional File Header. */
	//status = sys_lseek(obj->fd,SIZE_COFF_FILE_HEADER,0);
	status = obj->fd->f_op->llseek (obj->fd,SIZE_COFF_FILE_HEADER,0);
	

	optHdr->magic          = Coff_read16 (obj->fd, swap);
	optHdr->version        = Coff_read16 (obj->fd, swap);
	optHdr->sizeExeCode    = Coff_read32 (obj->fd, swap);
	optHdr->sizeInitData   = Coff_read32 (obj->fd, swap);
	optHdr->sizeUninitData = Coff_read32 (obj->fd, swap);
	optHdr->entry          = Coff_read32 (obj->fd, swap);
	optHdr->addrExe        = Coff_read32 (obj->fd, swap);
	optHdr->addrInitData   = Coff_read32 (obj->fd, swap);

    return status;
}


static int Coff_seekToSectHdr(Coff_Object *obj, UInt32 sectIndex,int swap)
{
    Int    status      = 0;
    Int32  optHdrSize;
    Int32  sectHdrOffset;
    optHdrSize = obj->optHdrSize;
	sectHdrOffset = (Int32)  (  SIZE_COFF_FILE_HEADER + optHdrSize + (sectIndex * SIZE_COFF_SECTION_HEADER));
	//status = sys_lseek(obj->fd,sectHdrOffset,0);
	status = obj->fd->f_op->llseek (obj->fd,sectHdrOffset,0);
    return status;
}

static int Coff_getSectHdr(Coff_Object *obj, UInt32 sectId, Coff_SectHdr *sectHdr)
{
    Int status = 0;
    int  swap = FALSE;
    Int32 i;

    swap = obj->isSwapped;

    status = Coff_seekToSectHdr(obj, sectId, swap);

	for (i = 0 ; i < COFF_NAME_LEN ; i++) {
		sectHdr->name [i] = Coff_read8 (obj->fd);
	}
	sectHdr->physicalAddress = Coff_read32 (obj->fd, swap);
	sectHdr->virtualAddress  = Coff_read32 (obj->fd, swap);
	sectHdr->size            = Coff_read32 (obj->fd, swap);
	sectHdr->fpRawData       = Coff_read32 (obj->fd, swap);
	sectHdr->fpReloc         = Coff_read32 (obj->fd, swap);
	sectHdr->fpLineNum       = Coff_read32 (obj->fd, swap);
	sectHdr->numReloc   = (UInt32) Coff_read32 (obj->fd, swap);
	sectHdr->numLine    = (UInt32) Coff_read32 (obj->fd, swap);
	sectHdr->flags      = (UInt32) Coff_read32 (obj->fd, swap);
	sectHdr->reserved   = (UInt16) Coff_read16 (obj->fd, swap);
	sectHdr->memPageNum = (UInt16) Coff_read16 (obj->fd, swap);

    return status;
}

static char *Coff_getString (Coff_Object *obj,char *str)
{
    Char *outStr = NULL;
    int swap = FALSE;
    UInt32 strOffset;
    UInt32 offsetinStrTab;

	if (*((UInt32 *) ((Ptr) str)) == 0) {
        swap = obj->isSwapped;
        if (swap == TRUE) {
            strOffset = BYTESWAP_LONG (*((UInt32 *) (Ptr) (str + 4)));
        } else {
            strOffset = *(UInt32 *) ((Ptr) (str + 4));
        }
        /*  --------------------------------------------------------------------
         *  Decrement the offset by 4 to account for the 4 bytes needed
         *  to store the size
         *  --------------------------------------------------------------------
         */
        strOffset -= 4;
        offsetinStrTab = ((UInt32)((Ptr) obj->strTab) + strOffset);
        /* Return the offset in the string table */
        outStr  = (char *) (offsetinStrTab);
    } else {
        outStr = str;/* Return the 'str' argument itself */
    } 
    return outStr;
}


#define  ARG_PTR_SIZE 4u

static int Coff_fillArgsBuffer(Processor_ProcArch procArch,
                         UInt32             argc,
                         Char **            argv,
                         UInt32             sectSize,
                         UInt32             loadAddr,
                         Ptr                argsBuf)
{
    Int     status    = 0;
    Int32 * bufPtr    = NULL;
    Char *  srcPtr    = NULL;
    //Int16 * dstPtr    = NULL;/* duhao modify for m3 */
	char * dstPtr    = NULL;
    Int32 * argvPtr   = NULL;
    UInt32  totalReqd;
    UInt32  length;
    UInt32  i;

    /*  ------------------------------------------------------------------------
     *  Compute total target buffer size required (in bytes). Memory requirement
     *  is calculated as:
     *      3 units for argc, argv and envp.
     *      argc units for storing the argv pointers.
     *      envc units for storing the envp pointers.
     *  For the current implementation 'envc' is 1 as the environment
     *  variables are not being passed, so it is set as NULL.
     *  ------------------------------------------------------------------------
     */
    /* For Coff_ProcArch_C64x */
    totalReqd = (UInt32) ((1 + argc ) * ARG_PTR_SIZE);

    for (i = 0 ; (i < argc) ; i++) {
        length = strlen (argv [i]);
        totalReqd += (length + 1);
        /* Extend to the next wordsize */
        totalReqd =  ((totalReqd + (ARG_PTR_SIZE - 1)) / ARG_PTR_SIZE) * ARG_PTR_SIZE;
    }

    if (totalReqd > sectSize) {
        status = -5 ;
    } else {
        bufPtr = (Int32 *) argsBuf;

        /*  --------------------------------------------------------------------
         *  Initialize the argument buffer with 0.
         *  --------------------------------------------------------------------
         */
        srcPtr = (Char *) argsBuf;
        for (i = 0 ; i < sectSize ; i++) {
            *srcPtr++ = 0;
        }

        /*  --------------------------------------------------------------------
         *  Fill the buffer according to the required format.
         *  --------------------------------------------------------------------
         */
        *bufPtr++ = (Int32) argc;

        argvPtr = bufPtr; /* Pointer to argv[0] */
        bufPtr  += argc;  /* Space for argv pointers */

        for ( ; argc > 0 ; argc--) {
            *argvPtr++ = (Int32) ((((Char *) ((Ptr) bufPtr)) - ((Char *) ((Ptr) argsBuf))) + loadAddr);
            srcPtr = *argv++;
            dstPtr = (char *) ((Ptr) bufPtr);/* duhao modify for m3 */
            while ((*srcPtr) != '\0') {
                *dstPtr = (Char)(*srcPtr);
                dstPtr++;
                srcPtr++;
            }
            *dstPtr++ = (Char) '\0';
            bufPtr    = (Int32 *) ((Ptr) dstPtr);
        }
    }
    return status ;
}


static AddrInfo M3_MemRegions [] = {
	{ /* KV UV MP SV SP */
		.addr   = { -1u, -1u, 0x55020000, 0x00000000, 0x00000000}, 
		.size   = 0x01000000
	}, /* RAM */ 
};

static AddrInfo DSP_MemRegions [] = {
	{ 
		.addr   = { -1u, -1u, 0x40800000, 0x00800000, 0x00800000}, 
		.size   = 0x00040000
	}, /* UMAP0 */ 
	{ 
		.addr   = { -1u, -1u, 0x40E00000, 0x00E00000, 0x00E00000}, 
		.size   = 0x00008000
	}, /* L1P */ 
	{ 
		.addr   = { -1u, -1u, 0x40F00000, 0x00F00000, 0x00F00000}, 
		.size   = 0x00008000
	}, /* L1D */ 
};


static UInt32 addr_translate (Processor_ProcArch   procArch, UInt32 srcAddr)
{
	int i,count;
	AddrInfo *pai = NULL;

	count = 0;
	
	if(procArch == Processor_ProcArch_C64x) {
		count = sizeof (DSP_MemRegions) / sizeof (AddrInfo);
		pai = DSP_MemRegions;
	} else if(procArch == Processor_ProcArch_M3) {
		count = sizeof (M3_MemRegions) / sizeof (AddrInfo);
		pai = M3_MemRegions;
	}
	for (i = 0; i < count; i++) {
		if( (srcAddr >= pai[i].addr [AddrType_SlavePhys]) && (srcAddr < (pai[i].addr [AddrType_SlavePhys] + pai[i].size))) {
			return pai[i].addr[AddrType_MasterPhys] + (srcAddr - pai[i].addr[AddrType_SlavePhys]);
		}
		
	}    
    return srcAddr;
}

static int Coff_load(struct file *fd, int argc, char **argv)
{
    Int                  status         = 0;
    UInt32               offsetSymTab  = 0;
    Char *               sectName		= NULL;
    Coff_FileHdr      	 fileHeader     = {0};
    Coff_OptHdr       	 optHeader       = {0};
    char                 symbolFromStrTab[COFF_NAME_LEN + 1];
    Coff_SectHdr  		 sectHeader;
    UInt32               i,j;

	Coff_Object *obj;

	obj = &g_obj;
	obj->fd = fd;
	obj->startAddr = 0;

	if( Coff_isValidFile (fd,COFF_MAGIC_64x) ) {
		obj->procArch = Processor_ProcArch_C64x;
	} else if(Coff_isValidFile (fd,COFF_MAGIC_M3)) {
		obj->procArch = Processor_ProcArch_M3;
	} else {
		printk("unkown proc arch.\n");
		return -10;
	}
	
	obj->isSwapped = Coff_isSwapped (fd);

	status = Coff_getSymTabDetails(fd,obj->isSwapped,&offsetSymTab,&(obj->numSymbols));
	if (obj->numSymbols != 0) {
		obj->strTab = Coff_getStringTable (obj,offsetSymTab);
		status = Coff_getSymTable(obj,offsetSymTab,&(obj->symTab),&(obj->numSymbols));
	}

	status = Coff_getFileHdr(obj, &fileHeader);
	obj->numSections = fileHeader.numSections;
	
	status = Coff_getOptHdr(obj,&optHeader,&(obj->optHdrSize));
	
	obj->sectionInfo = kmalloc(obj->numSections * sizeof (Coff_SectHdr),GFP_KERNEL);

    for (i = 0; i < fileHeader.numSections; i++) {
		UInt8 *iovirt;
		
		Coff_getSectHdr(obj, i, &sectHeader);

		for (j = 0 ; j < COFF_NAME_LEN ; j++) {
			symbolFromStrTab [j] = sectHeader.name [j];
		}
		symbolFromStrTab [COFF_NAME_LEN] = '\0';
		sectName = Coff_getString (obj, symbolFromStrTab);

		//printk("<dh0>%s,%x,%d\n",symbolFromStrTab,sectHeader.virtualAddress,sectHeader.size);
		if (!IS_LOADABLE_SECTION (sectHeader)) {
			continue;
		}

		iovirt = ioremap(addr_translate(obj->procArch,sectHeader.virtualAddress),sectHeader.size);
	
		printk("%s,addr=%x(%x),size=%d,flags=%x\n",symbolFromStrTab,sectHeader.virtualAddress,(UInt32)iovirt,sectHeader.size,sectHeader.flags);
		if (strcmp(sectName, ".args")==0) {
			sectHeader.data = kmalloc(sectHeader.size,GFP_KERNEL);
			memset(sectHeader.data,0,sectHeader.size);

			if(argc>0) {
				status = Coff_fillArgsBuffer (obj->procArch,
					(UInt32) argc,argv,
					(UInt32) sectHeader.size,
					(UInt32) sectHeader.virtualAddress,
					sectHeader.data);
			}
			memcpy(iovirt,sectHeader.data,sectHeader.size);
			/* Free the section data memory */
			kfree(sectHeader.data);
			sectHeader.data = NULL;
		} else {
			//sys_lseek(obj->fd,sectHeader.fpRawData,0);
			obj->fd->f_op->llseek(obj->fd,sectHeader.fpRawData,0);
			//sys_read(obj->fd,iovirt,sectHeader.size);
			obj->fd->f_op->read (obj->fd,iovirt,sectHeader.size,&(obj->fd->f_pos));
#if 0
		if(sectHeader.virtualAddress==0x800200) {
			int t;
			printk("arm phys addr is %x,fileoff=%x\n",addr_translate(obj->procArch,sectHeader.virtualAddress),sectHeader.fpRawData);
			for(t=0;t<32;t+=4) {
				printk("%x ",*(volatile u_int *)(iovirt + t));
			}
			printk("\n");
		}
#endif
			if(strcmp(sectName,".vecs")==0) {
				if(obj->procArch == Processor_ProcArch_C64x) {
					obj->startAddr = sectHeader.virtualAddress;
				}
			}
		}
		iounmap(iovirt);
    }

	if(!obj->startAddr) {
		obj->startAddr = optHeader.entry;
	}
    return status;
}


static int Coff_unload(void)
{
    Int status = 0;
    Coff_Object *obj = &g_obj;

	if (obj->sectionInfo != NULL) {
		kfree(obj->sectionInfo);
		obj->sectionInfo = NULL;
	}

	/* Free the symbol table. */
	if (obj->symTab != NULL) {
		kfree(obj->symTab);
		obj->symTab = NULL;
	}

	/* Free the string table. */
	if (obj->strTab != NULL) {
		kfree(obj->strTab);
		obj->strTab = NULL;
	}
	
    return status;
}


/*--------------------------------------------------------------------------------------------------------------*/
static void release_M3(int m3_id,UInt32 entry)
{
	u_int iovirt = 0;

	iovirt = (u_int)ioremap(DUCATI_BASE_ADDR,0x100);
	printk("pgctrl=0x%08x\n",*(volatile u_int *)(iovirt + 0x4));
	*(volatile u_int *)(iovirt + 0x4) = entry|1;
	iounmap((void *)iovirt);
	
	printk("rstctrl_reg=0x%08x\n",get_io(RM_DEFAULT_RSTCTRL));
	if(m3_id==M3_DSS_ID) {/* iss=vpss */
		printk("M3_vps is in Progress, Please wait.....");
		or_io(RM_DEFAULT_RSTCTRL, 0x08);/* reset */
		and_io(RM_DEFAULT_RSTCTRL, 0xF7);/* Bring M3_1 out of Reset */
		while( (get_io(RM_DEFAULT_RSTST)&0x08) != 0x08 );/* Check for M3_1 out of Reset */
		printk("done.\n");
	} else if( m3_id == M3_VIDEO_ID ) {/* rtos=video */
		printk("M3_vid is in Progress, Please wait.....");
		or_io(RM_DEFAULT_RSTCTRL, 0x04);/* reset */
		and_io(RM_DEFAULT_RSTCTRL, 0xFB);/* Bring M3_0 out of Reset */
		while( (get_io(RM_DEFAULT_RSTST) & 0x04) != 0x04 );/* Check for M3_0 out of Reset */
		printk("done.\n");	
	}

	/* Check Module is in Functional Mode */
	while( ((get_io(CM_DEFAULT_DUCATI_CLKCTRL) & 0x30000) >> 16) != 0 );
}

static void reset_M3(int m3_id)
{
	if(m3_id==M3_DSS_ID) {/* iss=vpss */
		or_io(RM_DEFAULT_RSTCTRL,0x08);/* reset */
	} else if( m3_id == M3_VIDEO_ID ) {/* rtos=video */
		or_io(RM_DEFAULT_RSTCTRL,0x04);/* reset */
	}
}

static void release_C64x(UInt32 entry)
{
	printk("C64x: entry is %x\n",entry);

	printk("C674x is in Progress, Please wait.....");	 									
	
	/* Cortex A8 must be in Supervisor Mode to Access the following two registers */
	set_io(DSPMEM_SLEEP, 0); /* Bring GEM L2RAM out of Power down Mode */
	set_io(DSP_BOOT_ADDR, entry & 0xfffffc00);
	or_io(DSP_BOOT_STAT, 0x1);

	/* Enable Clock to MMU CFG */
	set_io(CM_MMUCFG_CLKSTCTRL, 2); 
	set_io(CM_ALWON_MMUCFG_CLKCTRL, 2); 
	while(((get_io(CM_ALWON_MMUCFG_CLKCTRL) & 0x0)) != 0x0); 
	while(((get_io(CM_MMUCFG_CLKSTCTRL) & 0x100)) != 0x100); 

	/* Enable Clock to Data */
	set_io(CM_MMU_CLKSTCTRL, 2); 
	set_io(CM_ALWON_MMUDATA_CLKCTRL, 2); 
	while(((get_io(CM_ALWON_MMUDATA_CLKCTRL) & 0x0)) != 0x0); 
	while(((get_io(CM_MMU_CLKSTCTRL) & 0x100)) != 0x100); 

	/* Enable Clock to GEMSS */
	set_io(CM_GEM_CLKSTCTRL, 2); /* Enable Power Domain Transition */
	while(get_io(PM_ACTIVE_PWRSTST) != 0x37);/* Check Power is ON */
	set_io(CM_ACTIVE_GEM_CLKCTRL, 2);/* Enable GEMSS Clocks */
	
	while(((get_io(CM_GEM_CLKSTCTRL) & 0x700))!=0x700);/* GME Clocks are Active */
	set_io(RM_ACTIVE_RSTCTRL, 1);/* Issue GEM Warm Reset To access GEMSS memories */
	while(((get_io(RM_ACTIVE_RSTST) & 0x2)) != 0x2);/* GEMSS Warm Reset has been Asserted */

	if(entry) {
		set_io(RM_ACTIVE_RSTCTRL, 0); /* Bring GEM Core out of Reset */
		while(((get_io(RM_ACTIVE_RSTST) & 0x3)) != 0x3); /* GEM core core is out of Reset */
	}
	printk("done.\n");	
}

static void reset_C64x(void)
{
	set_io(RM_ACTIVE_RSTCTRL, 1);
}

/*--------------------------------------------------------------------------------------------------------------*/



//static int m3id = -1;
//module_param(m3id,int,0);

//static char *file = "./C674.out";/* "./testapp_dss.xm3" */
//module_param(file,charp,0);


#define ELF_MAGIC	0x464c457f

static void load_m3(int m3id,struct file *fd)
{
	Elf32_Ehdr fhdr;
	Elf32_Phdr phdr;
	Elf32_Shdr *pshdr;
	char *phstab;
	u_char *iovirt;	
	
	int i,j;

	/* read ELF header */
	fd->f_op->read (fd,(char *)&fhdr,sizeof(fhdr),&(fd->f_pos));
	printk("entry is %x,machine is %x\n",fhdr.e_entry,fhdr.e_machine);
	
	/* read ELF section table */
	fd->f_op->llseek (fd,fhdr.e_shoff,0);
	pshdr = kmalloc(fhdr.e_shnum*fhdr.e_shentsize,GFP_KERNEL);
	for(i=0;i<fhdr.e_shnum;i++) {
		fd->f_op->read (fd,(char *)&pshdr[i],fhdr.e_shentsize,&(fd->f_pos));
	}
	
	/* read head string table */
	phstab = kmalloc(pshdr[fhdr.e_shstrndx].sh_size,GFP_KERNEL);
	fd->f_op->llseek (fd,pshdr[fhdr.e_shstrndx].sh_offset,0);
	fd->f_op->read (fd,phstab,pshdr[fhdr.e_shstrndx].sh_size,&(fd->f_pos));
	
	
	/* read ELF header table */
	printk("type off    vaddr    paddr    filesz memsz   flags align name\n");
	for(i=0;i<fhdr.e_phnum;i++) {
		fd->f_op->llseek (fd,fhdr.e_phoff + i*fhdr.e_phentsize,0);
		fd->f_op->read (fd,(char *)&phdr,sizeof(phdr),&(fd->f_pos));
		printk("%-4x %-6x %08x %08x %-6x %-7x %5x %-1x     ",
			phdr.p_type,phdr.p_offset,phdr.p_vaddr,phdr.p_paddr,
			phdr.p_filesz,phdr.p_memsz,phdr.p_flags,phdr.p_align);
		if(phdr.p_filesz==0) {
			printk("\n");
			continue;
		}
		
		for(j=0;j<fhdr.e_shnum;j++) {
			if(phdr.p_offset == pshdr[j].sh_offset && phdr.p_vaddr == pshdr[j].sh_addr) {
				printk("[%s]\n",phstab + pshdr[j].sh_name);
				break;
			}
		}
		
#if 1
		/* fixme: process the seg which address bewteen M3 or DSP IO regions */
		iovirt = ioremap(addr_translate(Processor_ProcArch_M3,phdr.p_vaddr),phdr.p_filesz);
		if (strcmp(phstab + pshdr[j].sh_name, ".args")==0) {
			u_char *p = kmalloc(phdr.p_filesz,GFP_KERNEL);
			memset(p,0,phdr.p_filesz);
			
			
			//if(argc>0) {
			if(1) {
				char *argv[] = {
					"m3_test1",
					"m3_test2",
					0
				};
				Coff_fillArgsBuffer (Processor_ProcArch_M3,
					/*(UInt32) argc,argv,*/
					2,argv,
					(UInt32) phdr.p_filesz,
					(UInt32) phdr.p_vaddr,
					p);
			}
			
			memcpy(iovirt,p,phdr.p_filesz);
			
			kfree(p);
		} else {
			fd->f_op->llseek(fd,phdr.p_offset,0);
			fd->f_op->read (fd,iovirt,phdr.p_filesz,&(fd->f_pos));
			
			if(strcmp(phstab + pshdr[j].sh_name,".vecs")==0) {
			/*
			if(g_obj->procArch == Processor_ProcArch_C64x) {
			g_obj->startAddr = sectHeader.virtualAddress;
			}
				*/
			}
		}
		iounmap(iovirt);
#endif
	}
	printk("start M3 ELF.\n");
	release_M3(m3id, fhdr.e_entry);
	
	kfree(phstab);
	kfree(pshdr);
}

static void load_dsp(struct file *fd)
{
	char *argv[] = {
		"m3_test1",
		"m3_test2",
			0
	};

	release_C64x(0);
	Coff_load(fd,2,argv);
	if(g_obj.procArch == Processor_ProcArch_C64x) {
		printk("start C64x coff.\n");
		release_C64x(g_obj.startAddr);
	} else if(g_obj.procArch == Processor_ProcArch_M3) {
		printk("start M3 coff.\n");
		//release_M3(m3id, g_obj.startAddr);
	}
	Coff_unload();	
}

#if 0
char g_cpufile[3][64] = {
	"./vid_m3.out",
	"./vps_m3.out",
	"./C674.out"
};
//#else
char g_cpufile[3][64] = {
	"./vid_m3.bin",
	"./vps_m3.bin",
	"./C674.bin"
};
#else
char g_cpufile[2][64] = {
	"./vid_m3.bin",
	"./vps_m3.bin",
};
#endif


void load_bin(int procId,struct file *fd)
{
	Processor_ProcArch procArch;
	DSP_PROGRAM dp;
	int i;

	if(procId==CORE_C674) {
		release_C64x(0);
		procArch = Processor_ProcArch_C64x;
	} else {
		procArch = Processor_ProcArch_M3;
	}

	fd->f_op->read (fd,(char *)&dp,sizeof(dp),&(fd->f_pos));
	printk("boot addr is 0x%08x\n",dp.bootAddr);
	
	for(i=1;i<dp.blockCnt;i++) {
		u_char *iovirt = ioremap(addr_translate(procArch, dp.addr[i]), dp.size[i]*4);
		fd->f_op->llseek(fd, dp.blockOffset[i], 0);
		fd->f_op->read (fd, iovirt, dp.size[i]*4, &(fd->f_pos));
		iounmap(iovirt);
		printk("block%d: phys=0x%08x,size=%d download\n",i, dp.addr[i], dp.size[i]*4);
	}

	//dp.bootAddr = 0xb824cc00;
	if(procId==CORE_C674) {
		release_C64x(dp.bootAddr);
	} else {
		release_M3(procId, dp.bootAddr);
	}
}


int cpu_load(int procId,char *file)
{	
	struct file *fd;
	UInt32 fs;
	u_int fileflag;

	if(!file) {
		file = g_cpufile[procId];
	}
	
	memset(&g_obj,0,sizeof(g_obj));
	
	fs = get_fs();
	set_fs(get_ds());
	
	fd = filp_open(file,O_RDONLY,0);
	if(IS_ERR(fd)) {
		printk("cannot open file[%s]\n",file);
		return -ENOENT;	
	}
	
	fd->f_op->read (fd,(char *)&fileflag,sizeof(fileflag),&(fd->f_pos));
	fd->f_op->llseek (fd,0,0);

	if(fileflag == ELF_MAGIC) {/* ELF format */
		load_m3(procId, fd);
	} else if(fileflag == MAGIC_NUMBER) {
		load_bin(procId, fd);
	} else {
		load_dsp(fd);
	}

	filp_close(fd,NULL);
	set_fs(fs);
	
	return 0;
}

void cpu_stop(int procId)
{
	printk("ipc_stop_cpu procid is %d\n",procId);
	
	if(procId==CORE_VID) {/* rtos=video */
		reset_M3(M3_VIDEO_ID);
	} else if(procId==CORE_VPS) {/* iss=vpss */
		reset_M3(M3_DSS_ID);
	} else if(procId==CORE_C674) {	
		reset_C64x();
	}
}

