/**	@file data_types.h
 *	@note HangZhou Hikvision System Technology Co., Ltd. All Right Reserved.
 *	@brief basic data defines
 *
 *	@author		zhaoweibo
 *	@date		2011/03/25
 *
 *
 */
#ifndef __DATA_TYPES_H__
#define __DATA_TYPES_H__

#include "spi_flash.h"

#ifndef UINT32
typedef unsigned int UINT32;
#endif

#ifndef UINT16
typedef unsigned short UINT16;
#endif

#ifndef UINT8
typedef unsigned char UINT8;
#endif


#ifndef BYTE
typedef unsigned char BYTE;
#endif

#ifndef INT
typedef int INT;
#endif

#ifndef RET_STATUS
typedef int RET_STATUS;
#endif

#ifndef BOOL
typedef int BOOL;
#endif

#define TRUE		1
#define FALSE	0

/////////////////////////
#define ERR_OK				0

#define ERR_FAIL				-1
#define ERR_TIMEOUT			-2
#define ERR_INPUT_PARAM 	-3
#define ERR_POINTER			-4	//ָûа4ֽڶķʽ
#define ERR_BAD_PARAM		-5
#define ERR_OUT_RANGE		-6
#define ERR_BUSY			-7
//////////////////////////////////////

typedef struct 
{
    UINT32					baseAddr;       /* Flash Base Address used in fast mode */
    UINT8	                manufacturerId;	/* Manufacturer ID */
    UINT16	                deviceId;	    /* Device ID */
    UINT32                  sectorSize;     /* Size of each sector - all the same */
    UINT32                  sectorNumber;   /* Number of sectors */
    UINT32                  pageSize;       /* Page size - affect allignment */
    UINT32                  index;          /* index of the device in the sflash table (internal parameter) */

    struct spi_slave *spi;		//bus & cs
    struct spi_flash*	flash;	//base read , write and erase operation
} SPI_FLASH_INFO;


#endif

